//+------------------------------------------------------------------+
//|                                           MY-ST-ea.mq4           |
//|                       Copyright 2015,                            |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link ""
#define LongTrade 1
#define ShorTrade 2

//---- External input Required

extern int        MagicNumber=21215;
extern int        Slippage = 30;
extern double     PercentagePerTrade = 1.0;
extern bool       UseStopLoss=true; 
extern double     SLATRMultipler=1.0;
extern bool       UseTakeProfit=true;
extern double     TPATRMultipler=5.0;
extern bool       UseTrailingStop=false;
extern double     TSATRMultipler=2.0;
extern double     STMultipler = 2.0;
extern int        CloseEMA=25;
extern int        SMALength=200;
extern int        StarTime = 4;
extern int        FinishTime = 21;

bool dummyResult;
//+------------------------------------------------------------------+
//| Expert initialization function                            |
//+------------------------------------------------------------------+
int init ()
  {
//---- 

//----
   return(0) ;
   }
//+------------------------------------------------------------------+
//|     expet deinitialiazation function                  |
//+------------------------------------------------------------------+
int deinit ()
  {
//----

//----
   return (0) ;
  }
  
//+------------------------------------------------------------------+
//|     expet start foncion                                          |
//+------------------------------------------------------------------+ 
int start ()
  {  
//------ Declare Variables

   int cnt, ticket, Order, CurrenTime;
   
//---- Check at least 100 bars of data are available

     if (Bars<100) 
     {
      Print ("bars less than 100") ;
      return (0);
     }

//---- Calculate Lots per Trade

double Capital, CapitalRisked, SLAmount, LotsTraded, ATR, PointValue;

ATR = iATR (NULL, 0, 20, 1) ;                                     
PointValue = Point;                                                     
Capital = AccountFreeMargin () ;                                     //--- Capital in Trading Account
CapitalRisked = Capital * (PercentagePerTrade/100) ;       //--- Amount riscked per trade  
SLAmount = (ATR * SLATRMultipler / PointValue) ;          //--- Value of Stop Loss in Pips
LotsTraded = CapitalRisked/ (SLAmount) ;                      // Number of Lots per Trade

//------ Calculate Technical indicators

double ST1 = iCustom (NULL, 0, "Supertrend",  20, STMultipler, 0, 1) ;
double ST2 = iCustom (NULL, 0, "Supertrend",  20, STMultipler, 0, 2 ) ;

double SMA1 = iMA (NULL, 0, SMALength, 0, MODE_SMA, PRICE_CLOSE, 1) ;
double SMA2 = iMA (NULL, 0, SMALength, 0, MODE_SMA, PRICE_CLOSE, 2) ;

double EMA1 = iMA (NULL, 0, CloseEMA, 0, MODE_SMA, PRICE_CLOSE, 1) ;
double EMA2 = iMA (NULL, 0, CloseEMA, 0, MODE_SMA, PRICE_CLOSE, 2) ;

double Close1 = iClose (NULL, 0, 1) ;
double Close2 = iClose (NULL, 0, 2) ;

//---- Enter long Trade

    if (Close1 > ST1 && Close2 < ST2 && Close1 > SMA1)  Order = LongTrade;
    if (Close1 > SMA1 && Close2 < SMA2 && Close1 > ST1)  Order = LongTrade;

//------- Enter Short Trade

    if (Close1 < ST1 && Close2 > ST2 && Close1 < SMA1)  Order = ShorTrade;
    if (Close1 < SMA1 && Close2 > SMA2 && Close1 < ST1)  Order = ShorTrade;

//----- Check the Trading Time

      CurrenTime = Hour () ;
      if (CurrenTime>=StarTime && CurrenTime<=FinishTime)
      {
        
//----- Number of Trades Allowed

      int EATotal = 0;

    for (cnt = 0; cnt < OrdersTotal () ; cnt++)
        {
          dummyResult = OrderSelect (cnt, SELECT_BY_POS, MODE_TRADES) ;
          if (OrderMagicNumber ()  == MagicNumber)
             {
                EATotal += 1;
            }
        }
        
        if (EATotal < 1)
         {
          
          
// ------- Open Long Trades

            if (Order == LongTrade)
            {
                  if (UseStopLoss) double LongStopLossLevel = Ask - (ATR * SLATRMultipler)  ; else LongStopLossLevel = 0.0;
                  if (UseTakeProfit) double LongTakeProfitLevel = Ask + (ATR * TPATRMultipler) ;  else LongTakeProfitLevel = 0.0;
                        
                  ticket=OrderSend (Symbol () , OP_BUY, LotsTraded, Ask, Slippage, LongStopLossLevel, LongTakeProfitLevel, "Buy (#" + MagicNumber + ") ",MagicNumber, 0, Green) ;
                  if (ticket>0)
                  {
                             if (OrderSelect (ticket, SELECT_BY_TICKET,MODE_TRADES) ) Print ("Buy order opened  : ",OrderOpenPrice () ) ;
                  }
                  else Print ("Error opening BUY order  : ",GetLastError () ) ;
                  return (0) ;
            }

//------- Open Short Trade

            if (Order == ShorTrade)
            {
                  if  (UseStopLoss)  double ShortStopLossLevel = Bid + (ATR * SLATRMultipler)  ; else ShortStopLossLevel = 0.0;
                  if  (UseTakeProfit)  double ShortTakeProfitLevel = Bid - (ATR * TPATRMultipler)  ; else ShortStopLossLevel = 0.0;
                
                  ticket=OrderSend (Symbol() , OP_SELL, LotsTraded, Bid, Slippage, ShortStopLossLevel, ShortTakeProfitLevel, "Sell (#" + MagicNumber + ") ",MagicNumber, 0, Red) ;
                  if (ticket>0)
                  {
                     if (OrderSelect (ticket, SELECT_BY_TICKET, MODE_TRADES ) )  Print ("SELL order opened : ",OrderOpenPrice() ) ;
                  }                     
                  else Print ("Error opening SELL order : ",GetLastError () ) ; 
                  return (0) ;
            }
            return (0) ;
        }
   }
        
//-------- Check whether long position should be closed

    for (cnt=0;cnt<EATotal ; cnt++)
    {
      dummyResult = OrderSelect (cnt, SELECT_BY_POS, MODE_TRADES) ;
      if (OrderType () <=OP_SELL && OrderSymbol () ==Symbol() )
        {
          if (OrderType () ==OP_BUY && OrderSymbol() ==Symbol() )   //long position is open
          {
            // should it be closed?
            if (Close1  < EMA1 && Close2  > EMA2)
                  {
                    dummyResult = OrderClose (OrderTicket () ,OrderLots () ,Bid, Slippage, Violet); // close position
                    return (0) ; // exit
                  }
//---- Check for trailing stop on long position

                if (UseTrailingStop)
                  {
                    if (Bid-OrderOpenPrice () > (TSATRMultipler*ATR) )
                    {
                      if (OrderStopLoss () <Bid- (TSATRMultipler*ATR) )
                      {
                        dummyResult = OrderModify (OrderTicket () ,OrderOpenPrice () ,Bid- (TSATRMultipler*ATR) ,OrderTakeProfit () ,0,Green) ;
                        return (0) ;
                      }
                    } 
                 }     
              }
           else // go to short position
             {
            
//------Check whether short position should be closed

                        if (Close1 > EMA1 && Close2 < EMA2)
                         {
                          dummyResult = OrderClose (OrderTicket (),OrderLots () ,Ask, Slippage, Violet) ; // close position
                          return (0) ; //  exit
                         }
                          
//-----Check for trailing stop on short position

              if (UseTrailingStop)
                {
                  if  ( (OrderOpenPrice () -Ask) >( TSATRMultipler*ATR) )
                     {
                       if ( (OrderStopLoss () > (TSATRMultipler*ATR) )  ||  (OrderStopLoss () ==0) )
                       {
                        dummyResult = OrderModify (OrderTicket () ,OrderOpenPrice () ,Ask+ (TSATRMultipler*ATR) ,OrderTakeProfit () ,0,Red) ;
                          return (0) ;
                      }
                    }
                  }
                }
             }
          }
       return(0);
  }
//+------------------------------------------------------------------+  